/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.vsb.vis.visvzorservice;

import java.util.logging.Level;
import java.util.logging.Logger;
import javax.sql.DataSource;

/**
 *
 * @author nav79
 */
public class LideRepositoryFactory {

    private final DataSource dataSource;

    public static LideRepository getRepository(RepositoryType repositoryType) {
        switch (repositoryType) {
            case FILE:
                return new LideRepositoryImpl();
            case JDBC:
                return createJdbcRepository();
            default:
                throw new IllegalArgumentException("Unsupported Repository type");
        }
    }

    private static LideRepository createJdbcRepository() {
        try {
            Class.forName("org.apache.derby.jdbc.ClientDriver");
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(LideRepositoryFactory.class.getName()).log(Level.SEVERE, null, ex);
        }
        return new LideRepositoryJdbcImpl("jdbc:derby://localhost:1527/jat", "jat", "jat");
    }

    public LideRepository getManagedRepository() {
        return new LideRepositoryJdbcImpl(dataSource); //To change body of generated methods, choose Tools | Templates.
    }

    public LideRepositoryFactory(DataSource dataSource) {
        this.dataSource = dataSource;
    }
}
